/**
 * Summary.java
 *
 * File generated from the XValidationReport1::Summary uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.report;

// End of user code
import java.util.Date;
import java.util.GregorianCalendar;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Node;

/**
 * Description of the class Summary.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Summary", propOrder = { "gazelleXValidator", "validationDate", "validationResult",
		"validationCounters" })
@XmlRootElement(name = "Summary")
public class Summary implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	private static Logger log = LoggerFactory.getLogger(Summary.class);

	@XmlElement(name = "GazelleCrossValidator", required = true)
	private GazelleCrossValidatorDescription gazelleXValidator;
	@XmlElement(name = "ValidationDate", required = true)
	@XmlSchemaType(name = "dateTime")
	private javax.xml.datatype.XMLGregorianCalendar validationDate;
	@XmlElement(name = "ValidationResult", required = true)
	private ValidationResultType validationResult;
	@XmlElement(name = "ValidationCounters", required = true)
	private Counters validationCounters;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node xmlNodePresentation;

	/**
	 * Return gazelleXValidator.
	 * 
	 * @return gazelleXValidator
	 */
	public GazelleCrossValidatorDescription getGazelleXValidator() {
		return gazelleXValidator;
	}

	/**
	 * Set a value to attribute gazelleXValidator.
	 * 
	 * @param gazelleXValidator
	 *            .
	 */
	public void setGazelleXValidator(GazelleCrossValidatorDescription gazelleXValidator) {
		this.gazelleXValidator = gazelleXValidator;
	}

	/**
	 * Return validationDate.
	 * 
	 * @return validationDate
	 */
	public javax.xml.datatype.XMLGregorianCalendar getValidationDate() {
		return validationDate;
	}

	/**
	 * Set a value to attribute validationDate.
	 * 
	 * @param validationDate
	 *            .
	 */
	public void setValidationDate(javax.xml.datatype.XMLGregorianCalendar validationDate) {
		this.validationDate = validationDate;
	}

	public void setValidationDate(Date validationDate) {
		GregorianCalendar calendar = new GregorianCalendar();
		calendar.setTime(validationDate);
		try {
			this.validationDate = DatatypeFactory.newInstance().newXMLGregorianCalendar(calendar);
		} catch (DatatypeConfigurationException e) {
			log.error(e.getMessage(), e);
		}
	}

	/**
	 * Return validationResult.
	 * 
	 * @return validationResult
	 */
	public ValidationResultType getValidationResult() {
		return validationResult;
	}

	/**
	 * Set a value to attribute validationResult.
	 * 
	 * @param validationResult
	 *            .
	 */
	public void setValidationResult(ValidationResultType validationResult) {
		this.validationResult = validationResult;
	}

	/**
	 * Return validationCounters.
	 * 
	 * @return validationCounters
	 */
	public Counters getValidationCounters() {
		return validationCounters;
	}

	/**
	 * Set a value to attribute validationCounters.
	 * 
	 * @param validationCounters
	 *            .
	 */
	public void setValidationCounters(Counters validationCounters) {
		this.validationCounters = validationCounters;
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "Summary", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

}